# -*- coding: utf-8 -*-"

"""The Gyoto Lorene plug-in"""

# Make sure the stdplug and lorene plug-ins are loaded before
# attempting to load the Python bindings 
from gyoto.core import requirePlugin as __gyoto_tmp_requirePlugin
__gyoto_tmp_requirePlugin("stdplug")
__gyoto_tmp_requirePlugin("lorene")
del __gyoto_tmp_requirePlugin

# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""The Gyoto Lorene plug-in"""


from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    def swig_import_helper():
        import importlib
        pkg = __name__.rpartition('.')[0]
        mname = '.'.join((pkg, '_lorene')).lstrip('.')
        try:
            return importlib.import_module(mname)
        except ImportError:
            return importlib.import_module('_lorene')
    _lorene = swig_import_helper()
    del swig_import_helper
elif _swig_python_version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_lorene', [dirname(__file__)])
        except ImportError:
            import _lorene
            return _lorene
        try:
            _mod = imp.load_module('_lorene', fp, pathname, description)
        finally:
            if fp is not None:
                fp.close()
        return _mod
    _lorene = swig_import_helper()
    del swig_import_helper
else:
    import _lorene
del _swig_python_version_info

try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

import gyoto.core
class RotStar3_1(gyoto.core.Metric):
    """


    Numerical metric around a rotating star in 3+1 formalism.

    C++ includes: GyotoRotStar3_1.h 
    """

    __swig_setmethods__ = {}
    for _s in [gyoto.core.Metric]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RotStar3_1, name, value)
    __swig_getmethods__ = {}
    for _s in [gyoto.core.Metric]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, RotStar3_1, name)
    __repr__ = _swig_repr

    def getProperties(self):
        """
        getProperties(RotStar3_1 self) -> Property



        Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.RotStar3_1_getProperties(self)


    def plugins(self, *args):
        """
        plugins(RotStar3_1 self, vector_string plugname)
        plugins(RotStar3_1 self) -> vector_string
        """
        return _lorene.RotStar3_1_plugins(self, *args)


    def isThreadSafe(self):
        """
        isThreadSafe(RotStar3_1 self) -> bool



        Whether this class is thread-safe.

        Return True if this object is thread-safe, i.e. if an instance and its
        clone can be used in parallel threads (in the context of
        Scenery::raytrace()). Known objects which are not thread-safe include
        Lorene metrics and everything from the Python plug-in.

        The default implementation considers that the class itself is thread
        safe and recurses into the declared properties to check whether they
        are safe too. Classes that abide to the Object/Property paradigm and
        are themselves thread-safe have nothing special to do.

        Objects that clone children in their copy constructor that are not
        declared as properties must take these children into account.

        Classes that are never thread-safe must declare it. It acn be easily
        done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and
        GYOTO_PROPERTY_THREAD_UNSAFE in the class definition. 
        """
        return _lorene.RotStar3_1_isThreadSafe(self)

    __swig_destroy__ = _lorene.delete_RotStar3_1
    __del__ = lambda self: None

    def clone(self):
        """
        clone(RotStar3_1 self) -> RotStar3_1



        Cloner (uses RotStar3_1(file, integ_kind)) 
        """
        return _lorene.RotStar3_1_clone(self)


    def fileName(self, *args):
        """
        fileName(RotStar3_1 self, char const * arg2)
        fileName(RotStar3_1 self) -> char const *



        Get filename_. 
        """
        return _lorene.RotStar3_1_fileName(self, *args)


    def file(self, *args):
        """
        file(RotStar3_1 self, std::string const & arg2)
        file(RotStar3_1 self) -> std::string



        Get filename_. 
        """
        return _lorene.RotStar3_1_file(self, *args)


    def integKind(self, *args):
        """
        integKind(RotStar3_1 self, int arg2)
        integKind(RotStar3_1 self) -> int



        Get integ_kind_. 
        """
        return _lorene.RotStar3_1_integKind(self, *args)


    def genericIntegrator(self, *args):
        """
        genericIntegrator(RotStar3_1 self, bool arg2)
        genericIntegrator(RotStar3_1 self) -> bool



        Get !integ_kind_. 
        """
        return _lorene.RotStar3_1_genericIntegrator(self, *args)


    def myrk4(self, *args):
        """
        myrk4(RotStar3_1 self, Worldline line, double const [8] coord, double h, double [8] res) -> int
        myrk4(RotStar3_1 self, double const [6] coord, double h, double [6] res) -> int



        RK4 integrator. 
        """
        return _lorene.RotStar3_1_myrk4(self, *args)


    def myrk4_adaptive(self, *args):
        """
        myrk4_adaptive(RotStar3_1 self, Worldline line, double const [8] coord, double lastnorm, double normref, double [8] coordnew, double h0, double & h1, double h1max) -> int
        myrk4_adaptive(RotStar3_1 self, double const [6] coor, double lastnorm, double normref, double [6] coornew, double [2] cst, double & tdot_used, double h0, double & h1, double h1max, double & hused) -> int



        RK4 integrator (3+1)

        NB: we use the 6-coordinates, here, unlike the inherited function. 
        """
        return _lorene.RotStar3_1_myrk4_adaptive(self, *args)


    def diff(self, *args):
        """
        diff(RotStar3_1 self, double const [8] coord, double [8] res) -> int
        diff(RotStar3_1 self, double const [6] y, double [6] res, int arg4) -> int



        Alternate version of diff(const double coord[8], double res[8]) const.

        Using only 6 parameters. Last int is not used: it is only here to
        distinguish the signature of the two methods. Could have been done
        choosing another name, too, but hey... 
        """
        return _lorene.RotStar3_1_diff(self, *args)


    def Normalize4v(self, coordin, coordout, cst, tdot_used):
        """
        Normalize4v(RotStar3_1 self, double const [6] coordin, double [6] coordout, double const [2] cst, double & tdot_used)



        Tweak coordinates to insure conservation of cst. 
        """
        return _lorene.RotStar3_1_Normalize4v(self, coordin, coordout, cst, tdot_used)


    def gmunu(self, x, mu, nu):
        """
        gmunu(RotStar3_1 self, double const * x, int mu, int nu) -> double



        Metric coefficients.

        The default implementation calls double gmunu(const double * x, int
        mu, int nu) const.

        Parameters:
        -----------

        g:  4x4 array to store the coeefficients

        x:  4-position at which to compute the coefficients;

        Metric coefficient g, at point x 
        """
        return _lorene.RotStar3_1_gmunu(self, x, mu, nu)


    def christoffel(self, coord, alpha, mu, nu):
        """
        christoffel(RotStar3_1 self, double const [8] coord, int const alpha, int const mu, int const nu) -> double



        Chistoffel symbol.

        Value of Christoffel symbol at point (x1, x2, x3).

        1 on error, 0 otherwise 
        """
        return _lorene.RotStar3_1_christoffel(self, coord, alpha, mu, nu)


    def ScalarProd(self, pos, u1, u2):
        """
        ScalarProd(RotStar3_1 self, double const [4] pos, double const [4] u1, double const [4] u2) -> double



        Scalar product.

        Compute the scalarproduct of the two quadrivectors u1 and u2 in this
        Metric, at point pos expressed in coordinate system sys.

        Parameters:
        -----------

        pos:  4-position;

        u1:  1st quadrivector;

        u2:  2nd quadrivector;

        u1*u2 
        """
        return _lorene.RotStar3_1_ScalarProd(self, pos, u1, u2)


    def setParameter(self, arg2, arg3, arg4):
        """
        setParameter(RotStar3_1 self, std::string arg2, std::string arg3, std::string arg4) -> int



        Set parameter by Property (and name)

        This function is used when parsing an XML description, if Property (
        p) of this name is found (i.e. either p.name or p.name_false is equal
        to name). Implementation should fall-back on calling the direct's
        parent implementation:

        Parameters:
        -----------

        p:   Property that matches name ( p.name == name or p.name_false ==
        name)

        name:  XML name of the parameter (XML entity)

        content:  string representation of the value

        unit:  string representation of the unit 
        """
        return _lorene.RotStar3_1_setParameter(self, arg2, arg3, arg4)


    def __init__(self, *args):
        """
        __init__(Gyoto::Metric::RotStar3_1 self) -> RotStar3_1
        __init__(Gyoto::Metric::RotStar3_1 self, RotStar3_1 arg2) -> RotStar3_1
        __init__(Gyoto::Metric::RotStar3_1 self, Metric base) -> RotStar3_1
        __init__(Gyoto::Metric::RotStar3_1 self, long address) -> RotStar3_1



        Copy constructor. 
        """
        this = _lorene.new_RotStar3_1(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
RotStar3_1_swigregister = _lorene.RotStar3_1_swigregister
RotStar3_1_swigregister(RotStar3_1)
cvar = _lorene.cvar
RotStar3_1.properties = _lorene.cvar.RotStar3_1_properties
RotStar3_1.builtinPluginValue = _lorene.cvar.RotStar3_1_builtinPluginValue

class NumericalMetricLorene(gyoto.core.Metric):
    """Proxy of C++ Gyoto::Metric::NumericalMetricLorene class."""

    __swig_setmethods__ = {}
    for _s in [gyoto.core.Metric]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NumericalMetricLorene, name, value)
    __swig_getmethods__ = {}
    for _s in [gyoto.core.Metric]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NumericalMetricLorene, name)
    __repr__ = _swig_repr

    def getProperties(self):
        """
        getProperties(NumericalMetricLorene self) -> Property



        Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NumericalMetricLorene_getProperties(self)


    def plugins(self, *args):
        """
        plugins(NumericalMetricLorene self, vector_string plugname)
        plugins(NumericalMetricLorene self) -> vector_string
        """
        return _lorene.NumericalMetricLorene_plugins(self, *args)


    def isThreadSafe(self):
        """
        isThreadSafe(NumericalMetricLorene self) -> bool



        Whether this class is thread-safe.

        Return True if this object is thread-safe, i.e. if an instance and its
        clone can be used in parallel threads (in the context of
        Scenery::raytrace()). Known objects which are not thread-safe include
        Lorene metrics and everything from the Python plug-in.

        The default implementation considers that the class itself is thread
        safe and recurses into the declared properties to check whether they
        are safe too. Classes that abide to the Object/Property paradigm and
        are themselves thread-safe have nothing special to do.

        Objects that clone children in their copy constructor that are not
        declared as properties must take these children into account.

        Classes that are never thread-safe must declare it. It acn be easily
        done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and
        GYOTO_PROPERTY_THREAD_UNSAFE in the class definition. 
        """
        return _lorene.NumericalMetricLorene_isThreadSafe(self)


    def clone(self):
        """
        clone(NumericalMetricLorene self) -> NumericalMetricLorene



        Virtual copy constructor. 
        """
        return _lorene.NumericalMetricLorene_clone(self)

    __swig_destroy__ = _lorene.delete_NumericalMetricLorene
    __del__ = lambda self: None

    def setMetricSource(self):
        """
        setMetricSource(NumericalMetricLorene self)



        Access functions to get or set private attributes 
        """
        return _lorene.NumericalMetricLorene_setMetricSource(self)


    def directory(self, *args):
        """
        directory(NumericalMetricLorene self, std::string const & dir)
        directory(NumericalMetricLorene self) -> std::string
        """
        return _lorene.NumericalMetricLorene_directory(self, *args)


    def initialTime(self, *args):
        """
        initialTime(NumericalMetricLorene self) -> double
        initialTime(NumericalMetricLorene self, double t0)
        """
        return _lorene.NumericalMetricLorene_initialTime(self, *args)


    def horizon(self, *args):
        """
        horizon(NumericalMetricLorene self) -> double
        horizon(NumericalMetricLorene self, double t0)
        """
        return _lorene.NumericalMetricLorene_horizon(self, *args)


    def rico(self, *args):
        """
        rico(NumericalMetricLorene self) -> double
        rico(NumericalMetricLorene self, double r0)
        """
        return _lorene.NumericalMetricLorene_rico(self, *args)


    def hasSurface(self, *args):
        """
        hasSurface(NumericalMetricLorene self) -> bool
        hasSurface(NumericalMetricLorene self, bool s)
        """
        return _lorene.NumericalMetricLorene_hasSurface(self, *args)


    def hasAccelerationVector(self, *args):
        """
        hasAccelerationVector(NumericalMetricLorene self) -> bool
        hasAccelerationVector(NumericalMetricLorene self, bool aa)
        """
        return _lorene.NumericalMetricLorene_hasAccelerationVector(self, *args)


    def bosonstarcircular(self, *args):
        """
        bosonstarcircular(NumericalMetricLorene self) -> bool
        bosonstarcircular(NumericalMetricLorene self, bool arg2)
        """
        return _lorene.NumericalMetricLorene_bosonstarcircular(self, *args)


    def specifyMarginalOrbits(self, *args):
        """
        specifyMarginalOrbits(NumericalMetricLorene self) -> bool
        specifyMarginalOrbits(NumericalMetricLorene self, bool s)
        """
        return _lorene.NumericalMetricLorene_specifyMarginalOrbits(self, *args)


    def mapEt(self, *args):
        """
        mapEt(NumericalMetricLorene self) -> bool
        mapEt(NumericalMetricLorene self, bool s)
        """
        return _lorene.NumericalMetricLorene_mapEt(self, *args)


    def refineIntegStep(self, *args):
        """
        refineIntegStep(NumericalMetricLorene self) -> vector_double
        refineIntegStep(NumericalMetricLorene self, vector_double arg2)
        """
        return _lorene.NumericalMetricLorene_refineIntegStep(self, *args)


    def getShift_tab(self):
        """getShift_tab(NumericalMetricLorene self) -> Lorene::Vector **"""
        return _lorene.NumericalMetricLorene_getShift_tab(self)


    def getLapse_tab(self):
        """getLapse_tab(NumericalMetricLorene self) -> Lorene::Scalar **"""
        return _lorene.NumericalMetricLorene_getLapse_tab(self)


    def getGamcon_tab(self):
        """getGamcon_tab(NumericalMetricLorene self) -> Lorene::Sym_tensor **"""
        return _lorene.NumericalMetricLorene_getGamcon_tab(self)


    def getGamcov_tab(self):
        """getGamcov_tab(NumericalMetricLorene self) -> Lorene::Sym_tensor **"""
        return _lorene.NumericalMetricLorene_getGamcov_tab(self)


    def getTimes(self):
        """getTimes(NumericalMetricLorene self) -> double *"""
        return _lorene.NumericalMetricLorene_getTimes(self)


    def getNbtimes(self):
        """getNbtimes(NumericalMetricLorene self) -> int"""
        return _lorene.NumericalMetricLorene_getNbtimes(self)


    def getNssurf_tab(self):
        """getNssurf_tab(NumericalMetricLorene self) -> Lorene::Valeur **"""
        return _lorene.NumericalMetricLorene_getNssurf_tab(self)


    def getVsurf_tab(self):
        """getVsurf_tab(NumericalMetricLorene self) -> Lorene::Vector **"""
        return _lorene.NumericalMetricLorene_getVsurf_tab(self)


    def getAccel_tab(self):
        """getAccel_tab(NumericalMetricLorene self) -> Lorene::Vector **"""
        return _lorene.NumericalMetricLorene_getAccel_tab(self)


    def getLorentz_tab(self):
        """getLorentz_tab(NumericalMetricLorene self) -> Lorene::Scalar **"""
        return _lorene.NumericalMetricLorene_getLorentz_tab(self)


    def getHor_tab(self):
        """getHor_tab(NumericalMetricLorene self) -> Lorene::Valeur **"""
        return _lorene.NumericalMetricLorene_getHor_tab(self)


    def getRms(self):
        """
        getRms(NumericalMetricLorene self) -> double



        Returns the marginally stable (ISCO) radius Should be implemented in
        derived classes if useful If called on the base class, returns an
        error 
        """
        return _lorene.NumericalMetricLorene_getRms(self)


    def getRmb(self):
        """
        getRmb(NumericalMetricLorene self) -> double



        Returns the marginally bound radius Should be implemented in derived
        classes if useful If called on the base class, returns an error 
        """
        return _lorene.NumericalMetricLorene_getRmb(self)


    def setLapse_tab(self, lapse, ii):
        """setLapse_tab(NumericalMetricLorene self, Lorene::Scalar * lapse, int ii)"""
        return _lorene.NumericalMetricLorene_setLapse_tab(self, lapse, ii)


    def setShift_tab(self, shift, ii):
        """setShift_tab(NumericalMetricLorene self, Lorene::Vector * shift, int ii)"""
        return _lorene.NumericalMetricLorene_setShift_tab(self, shift, ii)


    def setGamcov_tab(self, gamcov, ii):
        """setGamcov_tab(NumericalMetricLorene self, Lorene::Sym_tensor * gamcov, int ii)"""
        return _lorene.NumericalMetricLorene_setGamcov_tab(self, gamcov, ii)


    def setGamcon_tab(self, gamcon, ii):
        """setGamcon_tab(NumericalMetricLorene self, Lorene::Sym_tensor * gamcon, int ii)"""
        return _lorene.NumericalMetricLorene_setGamcon_tab(self, gamcon, ii)


    def setKij_tab(self, kij, ii):
        """setKij_tab(NumericalMetricLorene self, Lorene::Sym_tensor * kij, int ii)"""
        return _lorene.NumericalMetricLorene_setKij_tab(self, kij, ii)


    def setTimes(self, time, ii):
        """setTimes(NumericalMetricLorene self, double time, int ii)"""
        return _lorene.NumericalMetricLorene_setTimes(self, time, ii)


    def getSpecificAngularMomentum(self, rr):
        """
        getSpecificAngularMomentum(NumericalMetricLorene self, double rr) -> double



        Returns the specific angular momentum l=-u_phi/u_t Should be
        implemented in derived classes if useful If called on the base class,
        returns an error 
        """
        return _lorene.NumericalMetricLorene_getSpecificAngularMomentum(self, rr)


    def getPotential(self, pos, l_cst):
        """
        getPotential(NumericalMetricLorene self, double const [4] pos, double l_cst) -> double



        Returns potential W=-ln(|u_t|) for a cst specific angular momentum
        l_cst Should be implemented in derived classes if useful If called on
        the base class, returns an error 
        """
        return _lorene.NumericalMetricLorene_getPotential(self, pos, l_cst)


    def myrk4(self, *args):
        """
        myrk4(NumericalMetricLorene self, double tt, double const [7] coord, double h, double [7] res) -> int
        myrk4(NumericalMetricLorene self, Worldline line, double const [8] coord, double h, double [8] res) -> int



        RK4 integrator. 
        """
        return _lorene.NumericalMetricLorene_myrk4(self, *args)


    def myrk4_adaptive(self, *args):
        """
        myrk4_adaptive(NumericalMetricLorene self, Worldline line, double const [8] coord, double lastnorm, double normref, double [8] coordnew, double h0, double & h1, double h1max) -> int
        myrk4_adaptive(NumericalMetricLorene self, double tt, double const [7] coor, double lastnorm, double normref, double [7] coornew, double const [2] cst, double & tdot_used, double h0, double & h1, double & hused, double h1max) -> int



        With energy integration also, coor=[E,r,th,ph,dE/dt,Vr,Vth,Vph]. 
        """
        return _lorene.NumericalMetricLorene_myrk4_adaptive(self, *args)


    def reverseR(self, tt, coord):
        """
        reverseR(NumericalMetricLorene self, double tt, double [7] coord)



        Reverse spatial vector if going through 0, without horizon 
        """
        return _lorene.NumericalMetricLorene_reverseR(self, tt, coord)


    def computeNBeta(self, coord, NN, beta):
        """
        computeNBeta(NumericalMetricLorene self, double const [4] coord, double & NN, double [3] beta)



        Compute lapse and shift at given coordinates 
        """
        return _lorene.NumericalMetricLorene_computeNBeta(self, coord, NN, beta)


    def gmunu(self, *args):
        """
        gmunu(NumericalMetricLorene self, double [4][4] g, double const [4] pos)
        gmunu(NumericalMetricLorene self, double const [4] IN_ARRAY1)
        gmunu(NumericalMetricLorene self, double const [4] x, int mu, int nu) -> double
        gmunu(NumericalMetricLorene self, double const [3] x, int indice_time, int mu, int nu) -> double



        Metric coefficients.

        The default implementation calls double gmunu(const double * x, int
        mu, int nu) const.

        Parameters:
        -----------

        g:  4x4 array to store the coeefficients

        x:  4-position at which to compute the coefficients;

        Metric coefficient g, at point x 
        """
        return _lorene.NumericalMetricLorene_gmunu(self, *args)


    def gmunu_up_dr(self, *args):
        """
        gmunu_up_dr(NumericalMetricLorene self, double const [4] x, int mu, int nu) -> double
        gmunu_up_dr(NumericalMetricLorene self, double const [3] x, int indice_time, int mu, int nu) -> double
        """
        return _lorene.NumericalMetricLorene_gmunu_up_dr(self, *args)


    def christoffel(self, *args):
        """
        christoffel(NumericalMetricLorene self, double const [4] coord, int const alpha, int const mu, int const nu) -> double
        christoffel(NumericalMetricLorene self, double const [4] coord, int const alpha, int const mu, int const nu, int const indice_time) -> double
        christoffel(NumericalMetricLorene self, double [4][4][4] dst, double const [4] coord) -> int
        christoffel(NumericalMetricLorene self, double [4][4][4] dst, double const [4] coord, int const indice_time) -> int
        """
        return _lorene.NumericalMetricLorene_christoffel(self, *args)


    def christoffel3(self, coord, indice_time, ii, jj, kk):
        """
        christoffel3(NumericalMetricLorene self, double const [3] coord, int const indice_time, int const ii, int const jj, int const kk) -> double



        3-Christoffels 
        """
        return _lorene.NumericalMetricLorene_christoffel3(self, coord, indice_time, ii, jj, kk)


    def setParticleProperties(self, line, coord):
        """
        setParticleProperties(NumericalMetricLorene self, Worldline line, double const [8] coord)



        Set Metric-specific constants of motion. Used e.g. in KerrBL. 
        """
        return _lorene.NumericalMetricLorene_setParticleProperties(self, line, coord)


    def Interpol3rdOrder(self, tt, indice_time, values):
        """
        Interpol3rdOrder(NumericalMetricLorene self, double tt, int indice_time, double [4] values) -> double



        3rd order interpolation routine

        Interpolation at order 3 at point tt, the considered function taking
        the values "values" at time indices "indices". 
        """
        return _lorene.NumericalMetricLorene_Interpol3rdOrder(self, tt, indice_time, values)


    def computeHorizon(self, *args):
        """
        computeHorizon(NumericalMetricLorene self, double const * pos) -> double
        computeHorizon(NumericalMetricLorene self, double const * pos, int indice) -> double
        """
        return _lorene.NumericalMetricLorene_computeHorizon(self, *args)


    def diff(self, *args):
        """
        diff(NumericalMetricLorene self, double const [8] coord, double [8] res) -> int
        diff(NumericalMetricLorene self, double tt, double const [7] y, double [7] res) -> int
        diff(NumericalMetricLorene self, double const [7] y, double [7] res, int indice_time) -> int
        """
        return _lorene.NumericalMetricLorene_diff(self, *args)


    def circularVelocity(self, *args):
        """
        circularVelocity(NumericalMetricLorene self, double const [4] coor, double [3] vel, double dir)
        circularVelocity(NumericalMetricLorene self, double const [4] coor, double [3] vel, double dir, int indice_time)



        Yield circular velocity at a given position.

        Give the velocity of a massive particle in circular orbit at the given
        position projected onto the equatorial plane. Such a velocity may not
        exist everywhere (or anywhere) for a given metric. This method is
        intended to be used by Astrobj classes such as Torus or ThinDisk.

        If keplerian_ is set to true, this method should return the Keplerian
        velcity instead (derived classes should ensure this, see
        KerrBL::circularVelocity() for instance).

        The default implementation throws an error if keplerian_ is set to
        false.

        Parameters:
        -----------

        pos:  input: position,

        vel:  output: velocity,

        dir:  1 for corotating, -1 for counterrotating. 
        """
        return _lorene.NumericalMetricLorene_circularVelocity(self, *args)


    def __init__(self, *args):
        """
        __init__(Gyoto::Metric::NumericalMetricLorene self) -> NumericalMetricLorene
        __init__(Gyoto::Metric::NumericalMetricLorene self, NumericalMetricLorene arg2) -> NumericalMetricLorene
        __init__(Gyoto::Metric::NumericalMetricLorene self, Metric base) -> NumericalMetricLorene
        __init__(Gyoto::Metric::NumericalMetricLorene self, long address) -> NumericalMetricLorene



        Copy constructor. 
        """
        this = _lorene.new_NumericalMetricLorene(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
NumericalMetricLorene_swigregister = _lorene.NumericalMetricLorene_swigregister
NumericalMetricLorene_swigregister(NumericalMetricLorene)
NumericalMetricLorene.properties = _lorene.cvar.NumericalMetricLorene_properties
NumericalMetricLorene.builtinPluginValue = _lorene.cvar.NumericalMetricLorene_builtinPluginValue

class NeutronStar(gyoto.core.StandardAstrobj):
    """


    Neutron star defined by its surface ; no emission.

    The underlying Gyoto::Metric::Generic gg_ instance must be a
    Gyoto::Metric::NumericalMetricLorene describing a neutron star.

    C++ includes: GyotoNeutronStar.h 
    """

    __swig_setmethods__ = {}
    for _s in [gyoto.core.StandardAstrobj]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NeutronStar, name, value)
    __swig_getmethods__ = {}
    for _s in [gyoto.core.StandardAstrobj]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NeutronStar, name)
    __repr__ = _swig_repr

    def getProperties(self):
        """
        getProperties(NeutronStar self) -> Property



        Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NeutronStar_getProperties(self)


    def plugins(self, *args):
        """
        plugins(NeutronStar self, vector_string plugname)
        plugins(NeutronStar self) -> vector_string
        """
        return _lorene.NeutronStar_plugins(self, *args)


    def clone(self):
        """
        clone(NeutronStar self) -> NeutronStar



        Cloner. 
        """
        return _lorene.NeutronStar_clone(self)

    __swig_destroy__ = _lorene.delete_NeutronStar
    __del__ = lambda self: None

    def metric(self, *args):
        """
        metric(NeutronStar self) -> Gyoto::SmartPointer< Gyoto::Metric::Generic >
        metric(NeutronStar self, Gyoto::SmartPointer< Gyoto::Metric::Generic > met)



        Set gg_. 
        """
        return _lorene.NeutronStar_metric(self, *args)


    def __call__(self, coord):
        """__call__(NeutronStar self, double const [4] coord) -> double"""
        return _lorene.NeutronStar___call__(self, coord)


    def getVelocity(self, pos, vel):
        """
        getVelocity(NeutronStar self, double const [4] pos, double [4] vel)



        Fluid velocity field.

        Fill vel with the 4-vector velocity of the fluid at 4-position pos.

        Parameters:
        -----------

        pos:  4-position at which to compute velocity;

        vel:  4-velocity at pos. 
        """
        return _lorene.NeutronStar_getVelocity(self, pos, vel)


    def __init__(self, *args):
        """
        __init__(Gyoto::Astrobj::NeutronStar self) -> NeutronStar
        __init__(Gyoto::Astrobj::NeutronStar self, std::string kin) -> NeutronStar
        __init__(Gyoto::Astrobj::NeutronStar self, NeutronStar o) -> NeutronStar
        __init__(Gyoto::Astrobj::NeutronStar self, Astrobj base) -> NeutronStar
        __init__(Gyoto::Astrobj::NeutronStar self, long address) -> NeutronStar



        Copy constructor. 
        """
        this = _lorene.new_NeutronStar(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
NeutronStar_swigregister = _lorene.NeutronStar_swigregister
NeutronStar_swigregister(NeutronStar)
NeutronStar.properties = _lorene.cvar.NeutronStar_properties
NeutronStar.builtinPluginValue = _lorene.cvar.NeutronStar_builtinPluginValue

class NeutronStarAnalyticEmission(NeutronStar):
    """


    Neutron star emitting at its surface an analytic emission, typically
    blackbody.

    The emission law is given by spectrum_.

    C++ includes: GyotoNeutronStarAnalyticEmission.h 
    """

    __swig_setmethods__ = {}
    for _s in [NeutronStar]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NeutronStarAnalyticEmission, name, value)
    __swig_getmethods__ = {}
    for _s in [NeutronStar]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NeutronStarAnalyticEmission, name)
    __repr__ = _swig_repr

    def getProperties(self):
        """
        getProperties(NeutronStarAnalyticEmission self) -> Property



        Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NeutronStarAnalyticEmission_getProperties(self)


    def plugins(self, *args):
        """
        plugins(NeutronStarAnalyticEmission self, vector_string plugname)
        plugins(NeutronStarAnalyticEmission self) -> vector_string
        """
        return _lorene.NeutronStarAnalyticEmission_plugins(self, *args)


    def clone(self):
        """
        clone(NeutronStarAnalyticEmission self) -> NeutronStarAnalyticEmission



        Cloner. 
        """
        return _lorene.NeutronStarAnalyticEmission_clone(self)

    __swig_destroy__ = _lorene.delete_NeutronStarAnalyticEmission
    __del__ = lambda self: None

    def spectrum(self, *args):
        """
        spectrum(NeutronStarAnalyticEmission self, Gyoto::SmartPointer< Gyoto::Spectrum::Generic > arg2)
        spectrum(NeutronStarAnalyticEmission self) -> Gyoto::SmartPointer< Gyoto::Spectrum::Generic >
        """
        return _lorene.NeutronStarAnalyticEmission_spectrum(self, *args)


    def emission(self, nu_em, dsem, _ph, _obj=0):
        """
        emission(NeutronStarAnalyticEmission self, double nu_em, double dsem, double [8] _ph, double [8] _obj=0) -> double
        emission(NeutronStarAnalyticEmission self, double nu_em, double dsem, double [8] _ph) -> double



        Specific intensity I for several values ofem

        Called by the default implementation for processHitQuantities().

        emission() computes the intensity I emitted by the small volume of
        length dsem. It should take self- absorption along dsem into account.

        Same as emission(double nu_em, double dsem, double coord_ph[8], double
        coord_obj[8]=NULL) const looping on several values of nu_em.

        Parameters:
        -----------

        Inu[nbnu]:  Output (must be set to a previously allocated array of
        doubles)

        nu_em[nbnu]:  Frequencies at emission

        nbnu:  Size of Inu[] and nu_em[]

        dsem:  Length over which to integrate inside the object

        coord_ph:   Photon coordinate

        coord_obj:  Emitter coordinate at current photon position

        I or dI [W m-2 sr-2] 
        """
        return _lorene.NeutronStarAnalyticEmission_emission(self, nu_em, dsem, _ph, _obj)


    def __init__(self, *args):
        """
        __init__(Gyoto::Astrobj::NeutronStarAnalyticEmission self) -> NeutronStarAnalyticEmission
        __init__(Gyoto::Astrobj::NeutronStarAnalyticEmission self, NeutronStarAnalyticEmission o) -> NeutronStarAnalyticEmission
        __init__(Gyoto::Astrobj::NeutronStarAnalyticEmission self, Astrobj base) -> NeutronStarAnalyticEmission
        __init__(Gyoto::Astrobj::NeutronStarAnalyticEmission self, long address) -> NeutronStarAnalyticEmission



        Copy constructor. 
        """
        this = _lorene.new_NeutronStarAnalyticEmission(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
NeutronStarAnalyticEmission_swigregister = _lorene.NeutronStarAnalyticEmission_swigregister
NeutronStarAnalyticEmission_swigregister(NeutronStarAnalyticEmission)
NeutronStarAnalyticEmission.properties = _lorene.cvar.NeutronStarAnalyticEmission_properties
NeutronStarAnalyticEmission.builtinPluginValue = _lorene.cvar.NeutronStarAnalyticEmission_builtinPluginValue

class NeutronStarModelAtmosphere(NeutronStar):
    """


    Neutron star emitting at its surface an emission provided by a FITS
    table.

    C++ includes: GyotoNeutronStarModelAtmosphere.h 
    """

    __swig_setmethods__ = {}
    for _s in [NeutronStar]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, NeutronStarModelAtmosphere, name, value)
    __swig_getmethods__ = {}
    for _s in [NeutronStar]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, NeutronStarModelAtmosphere, name)
    __repr__ = _swig_repr

    def getProperties(self):
        """
        getProperties(NeutronStarModelAtmosphere self) -> Property



        Get list of properties.

        This method is declared automatically by the GYOTO_OBJECT macro and
        defined automatically by the GYOTO_PROPERTY_END macro. 
        """
        return _lorene.NeutronStarModelAtmosphere_getProperties(self)


    def plugins(self, *args):
        """
        plugins(NeutronStarModelAtmosphere self, vector_string plugname)
        plugins(NeutronStarModelAtmosphere self) -> vector_string
        """
        return _lorene.NeutronStarModelAtmosphere_plugins(self, *args)


    def fillProperty(self, fmp, p):
        """
        fillProperty(NeutronStarModelAtmosphere self, FactoryMessenger fmp, Property p)



        Output a single Property to XML.

        The base implementation decides what to do based on the p.type. The
        format matches how setParameters() an setParameter() would interpret
        the XML descition.

        Overriding this method should be avoided, but makes sense in some
        cases (for instance Screen::fillProperty() selects a different unit
        for Distance based on its magnitude, so that stellar sizes are
        expressed in solar radii while smaller sizes can be expressed in
        meters and larger sizes in parsecs).

        Overriding implementation should fall-back on calling the
        implementation in the direct parent class: 
        """
        return _lorene.NeutronStarModelAtmosphere_fillProperty(self, fmp, p)


    def clone(self):
        """
        clone(NeutronStarModelAtmosphere self) -> NeutronStarModelAtmosphere



        Cloner. 
        """
        return _lorene.NeutronStarModelAtmosphere_clone(self)

    __swig_destroy__ = _lorene.delete_NeutronStarModelAtmosphere
    __del__ = lambda self: None

    def file(self, *args):
        """
        file(NeutronStarModelAtmosphere self, std::string const & f)
        file(NeutronStarModelAtmosphere self) -> std::string
        """
        return _lorene.NeutronStarModelAtmosphere_file(self, *args)


    def averageOverAngle(self, *args):
        """
        averageOverAngle(NeutronStarModelAtmosphere self, bool t)
        averageOverAngle(NeutronStarModelAtmosphere self) -> bool
        """
        return _lorene.NeutronStarModelAtmosphere_averageOverAngle(self, *args)


    def fitsRead(self, filename_):
        """fitsRead(NeutronStarModelAtmosphere self, std::string filename_)"""
        return _lorene.NeutronStarModelAtmosphere_fitsRead(self, filename_)


    def fitsWrite(self, filename_):
        """fitsWrite(NeutronStarModelAtmosphere self, std::string filename_)"""
        return _lorene.NeutronStarModelAtmosphere_fitsWrite(self, filename_)


    def setEmission(self, pattern):
        """
        setEmission(NeutronStarModelAtmosphere self, double * pattern)



        The pointer is copied directly, not the array content.

        This is a low-level function. Beware that: previously allocated array
        will not be freed automatically;

        array attached when the destructor is called will be freed. 
        """
        return _lorene.NeutronStarModelAtmosphere_setEmission(self, pattern)


    def surfgrav(self, pattern):
        """surfgrav(NeutronStarModelAtmosphere self, double * pattern)"""
        return _lorene.NeutronStarModelAtmosphere_surfgrav(self, pattern)


    def copyIntensity(self, pattern=None, naxes=0):
        """
        copyIntensity(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t const [3] naxes=0)
        copyIntensity(NeutronStarModelAtmosphere self, double const *const pattern=None)
        copyIntensity(NeutronStarModelAtmosphere self)



        NeutronStarModelAtmosphere::emission_ is freed if not NULL,
        reallocated, and pattern is copied into emission_.

        Finally, NeutronStarModelAtmosphere::nnu_,
        NeutronStarModelAtmosphere::ni_, and NeutronStarModelAtmosphere::nsg_
        are set according to naxes.

        Parameters:
        -----------

        pattern:  Array to copy as emission_. May be NULL in which case
        emission_ is simply deallocated and set to NULL.

        naxes:  { nnu_, ni_, nsg_ }. 
        """
        return _lorene.NeutronStarModelAtmosphere_copyIntensity(self, pattern, naxes)


    def getIntensity(self):
        """
        getIntensity(NeutronStarModelAtmosphere self) -> double const *



        Get NeutronStarModelAtmosphere::emission_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getIntensity(self)


    def getIntensityNaxes(self, naxes):
        """
        getIntensityNaxes(NeutronStarModelAtmosphere self, size_t [3] naxes)



        Get NeutronStarModelAtmosphere::nnu_, NeutronStarModelAtmosphere::ni_,
        and NeutronStarModelAtmosphere::nsg_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getIntensityNaxes(self, naxes)


    def copyGridSurfgrav(self, pattern=None, nsg=0):
        """
        copyGridSurfgrav(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t nsg=0)
        copyGridSurfgrav(NeutronStarModelAtmosphere self, double const *const pattern=None)
        copyGridSurfgrav(NeutronStarModelAtmosphere self)
        """
        return _lorene.NeutronStarModelAtmosphere_copyGridSurfgrav(self, pattern, nsg)


    def getGridSurfgrav(self):
        """
        getGridSurfgrav(NeutronStarModelAtmosphere self) -> double const *



        Get NeutronStarModelAtmosphere::surfgrav_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getGridSurfgrav(self)


    def copyGridCosi(self, pattern=None, ni=0):
        """
        copyGridCosi(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t ni=0)
        copyGridCosi(NeutronStarModelAtmosphere self, double const *const pattern=None)
        copyGridCosi(NeutronStarModelAtmosphere self)
        """
        return _lorene.NeutronStarModelAtmosphere_copyGridCosi(self, pattern, ni)


    def getGridCosi(self):
        """
        getGridCosi(NeutronStarModelAtmosphere self) -> double const *



        Get NeutronStarModelAtmosphere::cosi_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getGridCosi(self)


    def copyGridFreq(self, pattern=None, ni=0):
        """
        copyGridFreq(NeutronStarModelAtmosphere self, double const *const pattern=None, size_t ni=0)
        copyGridFreq(NeutronStarModelAtmosphere self, double const *const pattern=None)
        copyGridFreq(NeutronStarModelAtmosphere self)
        """
        return _lorene.NeutronStarModelAtmosphere_copyGridFreq(self, pattern, ni)


    def getGridFreq(self):
        """
        getGridFreq(NeutronStarModelAtmosphere self) -> double const *



        Get NeutronStarModelAtmosphere::freq_. 
        """
        return _lorene.NeutronStarModelAtmosphere_getGridFreq(self)


    def emission(self, nu_em, dsem, _ph, _obj=0):
        """
        emission(NeutronStarModelAtmosphere self, double nu_em, double dsem, double [8] _ph, double [8] _obj=0) -> double
        emission(NeutronStarModelAtmosphere self, double nu_em, double dsem, double [8] _ph) -> double



        Specific intensity I for several values ofem

        Called by the default implementation for processHitQuantities().

        emission() computes the intensity I emitted by the small volume of
        length dsem. It should take self- absorption along dsem into account.

        Same as emission(double nu_em, double dsem, double coord_ph[8], double
        coord_obj[8]=NULL) const looping on several values of nu_em.

        Parameters:
        -----------

        Inu[nbnu]:  Output (must be set to a previously allocated array of
        doubles)

        nu_em[nbnu]:  Frequencies at emission

        nbnu:  Size of Inu[] and nu_em[]

        dsem:  Length over which to integrate inside the object

        coord_ph:   Photon coordinate

        coord_obj:  Emitter coordinate at current photon position

        I or dI [W m-2 sr-2] 
        """
        return _lorene.NeutronStarModelAtmosphere_emission(self, nu_em, dsem, _ph, _obj)


    def __init__(self, *args):
        """
        __init__(Gyoto::Astrobj::NeutronStarModelAtmosphere self) -> NeutronStarModelAtmosphere
        __init__(Gyoto::Astrobj::NeutronStarModelAtmosphere self, NeutronStarModelAtmosphere o) -> NeutronStarModelAtmosphere
        __init__(Gyoto::Astrobj::NeutronStarModelAtmosphere self, Astrobj base) -> NeutronStarModelAtmosphere
        __init__(Gyoto::Astrobj::NeutronStarModelAtmosphere self, long address) -> NeutronStarModelAtmosphere



        Copy constructor. 
        """
        this = _lorene.new_NeutronStarModelAtmosphere(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
NeutronStarModelAtmosphere_swigregister = _lorene.NeutronStarModelAtmosphere_swigregister
NeutronStarModelAtmosphere_swigregister(NeutronStarModelAtmosphere)
NeutronStarModelAtmosphere.properties = _lorene.cvar.NeutronStarModelAtmosphere_properties
NeutronStarModelAtmosphere.builtinPluginValue = _lorene.cvar.NeutronStarModelAtmosphere_builtinPluginValue

# This file is compatible with both classic and new-style classes.


